diff --git src/widgets/styles/qmacstyle_mac.mm src/widgets/styles/qmacstyle_mac.mm
index e6436f82a6..be7c58cf72 100644
--- src/widgets/styles/qmacstyle_mac.mm
+++ src/widgets/styles/qmacstyle_mac.mm
@@ -655,294 +659,288 @@ static QSize qt_aqua_get_known_size(QStyle::ContentsType ct, const QWidget *widg
         if (widg->font().pointSize() > font.pointSize())
             return ret;
     }
-
+    
     if (ct == QStyle::CT_CustomBase && widg) {
-#if QT_CONFIG(pushbutton)
         if (qobject_cast<const QPushButton *>(widg))
             ct = QStyle::CT_PushButton;
-#endif
         else if (qobject_cast<const QRadioButton *>(widg))
             ct = QStyle::CT_RadioButton;
-#if QT_CONFIG(checkbox)
         else if (qobject_cast<const QCheckBox *>(widg))
             ct = QStyle::CT_CheckBox;
-#endif
-#if QT_CONFIG(combobox)
+#ifndef QT_NO_COMBOBOX
         else if (qobject_cast<const QComboBox *>(widg))
             ct = QStyle::CT_ComboBox;
 #endif
-#if QT_CONFIG(toolbutton)
+#ifndef QT_NO_TOOLBUTTON
         else if (qobject_cast<const QToolButton *>(widg))
             ct = QStyle::CT_ToolButton;
 #endif
         else if (qobject_cast<const QSlider *>(widg))
             ct = QStyle::CT_Slider;
-#if QT_CONFIG(progressbar)
+#ifndef QT_NO_PROGRESSBAR
         else if (qobject_cast<const QProgressBar *>(widg))
             ct = QStyle::CT_ProgressBar;
 #endif
-#if QT_CONFIG(lineedit)
+#ifndef QT_NO_LINEEDIT
         else if (qobject_cast<const QLineEdit *>(widg))
             ct = QStyle::CT_LineEdit;
 #endif
         else if (qobject_cast<const QHeaderView *>(widg))
             ct = QStyle::CT_HeaderSection;
-#if QT_CONFIG(menubar)
+#ifndef QT_NO_MENUBAR
         else if (qobject_cast<const QMenuBar *>(widg))
             ct = QStyle::CT_MenuBar;
 #endif
-#if QT_CONFIG(sizegrip)
+#ifndef QT_NO_SIZEGRIP
         else if (qobject_cast<const QSizeGrip *>(widg))
             ct = QStyle::CT_SizeGrip;
 #endif
         else
             return ret;
     }
-
+    
     switch (ct) {
-#if QT_CONFIG(pushbutton)
-    case QStyle::CT_PushButton: {
-        const QPushButton *psh = qobject_cast<const QPushButton *>(widg);
-        // If this comparison is false, then the widget was not a push button.
-        // This is bad and there's very little we can do since we were requested to find a
-        // sensible size for a widget that pretends to be a QPushButton but is not.
-        if(psh) {
-            QString buttonText = qt_mac_removeMnemonics(psh->text());
-            if (buttonText.contains(QLatin1Char('\n')))
-                ret = QSize(-1, -1);
-            else if (sz == QAquaSizeLarge)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
+        case QStyle::CT_PushButton: {
+            const QPushButton *psh = qobject_cast<const QPushButton *>(widg);
+            // If this comparison is false, then the widget was not a push button.
+            // This is bad and there's very little we can do since we were requested to find a
+            // sensible size for a widget that pretends to be a QPushButton but is not.
+            if(psh) {
+                QString buttonText = qt_mac_removeMnemonics(psh->text());
+                if (buttonText.contains(QLatin1Char('\n')))
+                    ret = QSize(-1, -1);
+                else if (sz == QAquaSizeLarge)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
+                else if (sz == QAquaSizeSmall)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPushButtonHeight));
+                else if (sz == QAquaSizeMini)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPushButtonHeight));
+                
+                if (!psh->icon().isNull()){
+                    // If the button got an icon, and the icon is larger than the
+                    // button, we can't decide on a default size
+                    ret.setWidth(-1);
+                    if (ret.height() < psh->iconSize().height())
+                        ret.setHeight(-1);
+                }
+                else if (buttonText == QLatin1String("OK") || buttonText == QLatin1String("Cancel")){
+                    // Aqua Style guidelines restrict the size of OK and Cancel buttons to 68 pixels.
+                    // However, this doesn't work for German, therefore only do it for English,
+                    // I suppose it would be better to do some sort of lookups for languages
+                    // that like to have really long words.
+                    ret.setWidth(77 - 8);
+                }
+            } else {
+                // The only sensible thing to do is to return whatever the style suggests...
+                if (sz == QAquaSizeLarge)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
+                else if (sz == QAquaSizeSmall)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPushButtonHeight));
+                else if (sz == QAquaSizeMini)
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPushButtonHeight));
+                else
+                    // Since there's no default size we return the large size...
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
+            }
+#if 0 //Not sure we are applying the rules correctly for RadioButtons/CheckBoxes --Sam
+        } else if (ct == QStyle::CT_RadioButton) {
+            QRadioButton *rdo = static_cast<QRadioButton *>(widg);
+            // Exception for case where multiline radio button text requires no size constrainment
+            if (rdo->text().find('\n') != -1)
+                return ret;
+            if (sz == QAquaSizeLarge)
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricRadioButtonHeight));
             else if (sz == QAquaSizeSmall)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPushButtonHeight));
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallRadioButtonHeight));
             else if (sz == QAquaSizeMini)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPushButtonHeight));
-
-            if (!psh->icon().isNull()){
-                // If the button got an icon, and the icon is larger than the
-                // button, we can't decide on a default size
-                ret.setWidth(-1);
-                if (ret.height() < psh->iconSize().height())
-                    ret.setHeight(-1);
-            }
-            else if (buttonText == QLatin1String("OK") || buttonText == QLatin1String("Cancel")){
-                // Aqua Style guidelines restrict the size of OK and Cancel buttons to 68 pixels.
-                // However, this doesn't work for German, therefore only do it for English,
-                // I suppose it would be better to do some sort of lookups for languages
-                // that like to have really long words.
-                ret.setWidth(77 - 8);
-            }
-        } else {
-            // The only sensible thing to do is to return whatever the style suggests...
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniRadioButtonHeight));
+        } else if (ct == QStyle::CT_CheckBox) {
             if (sz == QAquaSizeLarge)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricCheckBoxHeight));
             else if (sz == QAquaSizeSmall)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPushButtonHeight));
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallCheckBoxHeight));
             else if (sz == QAquaSizeMini)
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPushButtonHeight));
-            else
-                // Since there's no default size we return the large size...
-                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPushButtonHeight));
-         }
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniCheckBoxHeight));
 #endif
-#if 0 //Not sure we are applying the rules correctly for RadioButtons/CheckBoxes --Sam
-    } else if (ct == QStyle::CT_RadioButton) {
-        QRadioButton *rdo = static_cast<QRadioButton *>(widg);
-        // Exception for case where multiline radio button text requires no size constrainment
-        if (rdo->text().find('\n') != -1)
-            return ret;
-        if (sz == QAquaSizeLarge)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricRadioButtonHeight));
-        else if (sz == QAquaSizeSmall)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallRadioButtonHeight));
-        else if (sz == QAquaSizeMini)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniRadioButtonHeight));
-    } else if (ct == QStyle::CT_CheckBox) {
-        if (sz == QAquaSizeLarge)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricCheckBoxHeight));
-        else if (sz == QAquaSizeSmall)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallCheckBoxHeight));
-        else if (sz == QAquaSizeMini)
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniCheckBoxHeight));
-#endif
-        break;
-    }
-    case QStyle::CT_SizeGrip:
-        if (sz == QAquaSizeLarge || sz == QAquaSizeSmall) {
-            HIRect r;
-            HIPoint p = { 0, 0 };
-            HIThemeGrowBoxDrawInfo gbi;
-            gbi.version = 0;
-            gbi.state = kThemeStateActive;
-            gbi.kind = kHIThemeGrowBoxKindNormal;
-            gbi.direction = QApplication::isRightToLeft() ? kThemeGrowLeft | kThemeGrowDown
-                                                          : kThemeGrowRight | kThemeGrowDown;
-            gbi.size = sz == QAquaSizeSmall ? kHIThemeGrowBoxSizeSmall : kHIThemeGrowBoxSizeNormal;
-            if (HIThemeGetGrowBoxBounds(&p, &gbi, &r) == noErr) {
-                int width = 0;
-#if QT_CONFIG(mdiarea)
-            if (widg && qobject_cast<QMdiSubWindow *>(widg->parentWidget()))
-                width = r.size.width;
+            break;
+        }
+        case QStyle::CT_SizeGrip:
+            if (sz == QAquaSizeLarge || sz == QAquaSizeSmall) {
+                HIRect r;
+                HIPoint p = { 0, 0 };
+                HIThemeGrowBoxDrawInfo gbi;
+                gbi.version = 0;
+                gbi.state = kThemeStateActive;
+                gbi.kind = kHIThemeGrowBoxKindNormal;
+                gbi.direction = QApplication::isRightToLeft() ? kThemeGrowLeft | kThemeGrowDown
+                : kThemeGrowRight | kThemeGrowDown;
+                gbi.size = sz == QAquaSizeSmall ? kHIThemeGrowBoxSizeSmall : kHIThemeGrowBoxSizeNormal;
+                if (HIThemeGetGrowBoxBounds(&p, &gbi, &r) == noErr) {
+                    int width = 0;
+#ifndef QT_NO_MDIAREA
+                    if (widg && qobject_cast<QMdiSubWindow *>(widg->parentWidget()))
+                        width = r.size.width;
 #endif
-                ret = QSize(width, r.size.height);
+                    ret = QSize(width, r.size.height);
+                }
             }
-        }
-        break;
-    case QStyle::CT_ComboBox:
-        switch (sz) {
-        case QAquaSizeLarge:
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPopupButtonHeight));
-            break;
-        case QAquaSizeSmall:
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPopupButtonHeight));
-            break;
-        case QAquaSizeMini:
-            ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPopupButtonHeight));
             break;
-        default:
+        case QStyle::CT_ComboBox:
+            switch (sz) {
+                case QAquaSizeLarge:
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricPopupButtonHeight));
+                    break;
+                case QAquaSizeSmall:
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricSmallPopupButtonHeight));
+                    break;
+                case QAquaSizeMini:
+                    ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricMiniPopupButtonHeight));
+                    break;
+                default:
+                    break;
+            }
             break;
-        }
-        break;
-    case QStyle::CT_ToolButton:
-        if (sz == QAquaSizeSmall) {
-            int width = 0, height = 0;
-            if (szHint == QSize(-1, -1)) { //just 'guess'..
-#if QT_CONFIG(toolbutton)
-                const QToolButton *bt = qobject_cast<const QToolButton *>(widg);
-                // If this conversion fails then the widget was not what it claimed to be.
-                if(bt) {
-                    if (!bt->icon().isNull()) {
-                        QSize iconSize = bt->iconSize();
-                        QSize pmSize = bt->icon().actualSize(QSize(32, 32), QIcon::Normal);
-                        width = qMax(width, qMax(iconSize.width(), pmSize.width()));
-                        height = qMax(height, qMax(iconSize.height(), pmSize.height()));
-                    }
-                    if (!bt->text().isNull() && bt->toolButtonStyle() != Qt::ToolButtonIconOnly) {
-                        int text_width = bt->fontMetrics().width(bt->text()),
-                           text_height = bt->fontMetrics().height();
-                        if (bt->toolButtonStyle() == Qt::ToolButtonTextUnderIcon) {
-                            width = qMax(width, text_width);
-                            height += text_height;
-                        } else {
-                            width += text_width;
-                            width = qMax(height, text_height);
+        case QStyle::CT_ToolButton:
+            if (sz == QAquaSizeSmall) {
+                int width = 0, height = 0;
+                if (szHint == QSize(-1, -1)) { //just 'guess'..
+#ifndef QT_NO_TOOLBUTTON
+                    const QToolButton *bt = qobject_cast<const QToolButton *>(widg);
+                    // If this conversion fails then the widget was not what it claimed to be.
+                    if(bt) {
+                        if (!bt->icon().isNull()) {
+                            QSize iconSize = bt->iconSize();
+                            QSize pmSize = bt->icon().actualSize(QSize(32, 32), QIcon::Normal);
+                            width = qMax(width, qMax(iconSize.width(), pmSize.width()));
+                            height = qMax(height, qMax(iconSize.height(), pmSize.height()));
                         }
-                    }
-                } else
+                        if (!bt->text().isNull() && bt->toolButtonStyle() != Qt::ToolButtonIconOnly) {
+                            int text_width = bt->fontMetrics().width(bt->text()),
+                            text_height = bt->fontMetrics().height();
+                            if (bt->toolButtonStyle() == Qt::ToolButtonTextUnderIcon) {
+                                width = qMax(width, text_width);
+                                height += text_height;
+                            } else {
+                                width += text_width;
+                                width = qMax(height, text_height);
+                            }
+                        }
+                    } else
 #endif
-                {
-                    // Let's return the size hint...
+                    {
+                        // Let's return the size hint...
+                        width = szHint.width();
+                        height = szHint.height();
+                    }
+                } else {
                     width = szHint.width();
                     height = szHint.height();
                 }
-            } else {
-                width = szHint.width();
-                height = szHint.height();
+                width =  qMax(20, width +  5); //border
+                height = qMax(20, height + 5); //border
+                ret = QSize(width, height);
             }
-            width =  qMax(20, width +  5); //border
-            height = qMax(20, height + 5); //border
-            ret = QSize(width, height);
-        }
-        break;
-    case QStyle::CT_Slider: {
-        int w = -1;
-        const QSlider *sld = qobject_cast<const QSlider *>(widg);
-        // If this conversion fails then the widget was not what it claimed to be.
-        if(sld) {
-            if (sz == QAquaSizeLarge) {
-                if (sld->orientation() == Qt::Horizontal) {
-                    w = qt_mac_aqua_get_metric(kThemeMetricHSliderHeight);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricHSliderTickHeight);
-                } else {
-                    w = qt_mac_aqua_get_metric(kThemeMetricVSliderWidth);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricVSliderTickWidth);
-                }
-            } else if (sz == QAquaSizeSmall) {
-                if (sld->orientation() == Qt::Horizontal) {
-                    w = qt_mac_aqua_get_metric(kThemeMetricSmallHSliderHeight);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricSmallHSliderTickHeight);
-                } else {
-                    w = qt_mac_aqua_get_metric(kThemeMetricSmallVSliderWidth);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricSmallVSliderTickWidth);
-                }
-            } else if (sz == QAquaSizeMini) {
-                if (sld->orientation() == Qt::Horizontal) {
-                    w = qt_mac_aqua_get_metric(kThemeMetricMiniHSliderHeight);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricMiniHSliderTickHeight);
-                } else {
-                    w = qt_mac_aqua_get_metric(kThemeMetricMiniVSliderWidth);
-                    if (sld->tickPosition() != QSlider::NoTicks)
-                        w += qt_mac_aqua_get_metric(kThemeMetricMiniVSliderTickWidth);
+            break;
+        case QStyle::CT_Slider: {
+            int w = -1;
+            const QSlider *sld = qobject_cast<const QSlider *>(widg);
+            // If this conversion fails then the widget was not what it claimed to be.
+            if(sld) {
+                if (sz == QAquaSizeLarge) {
+                    if (sld->orientation() == Qt::Horizontal) {
+                        w = qt_mac_aqua_get_metric(kThemeMetricHSliderHeight);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricHSliderTickHeight);
+                    } else {
+                        w = qt_mac_aqua_get_metric(kThemeMetricVSliderWidth);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricVSliderTickWidth);
+                    }
+                } else if (sz == QAquaSizeSmall) {
+                    if (sld->orientation() == Qt::Horizontal) {
+                        w = qt_mac_aqua_get_metric(kThemeMetricSmallHSliderHeight);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricSmallHSliderTickHeight);
+                    } else {
+                        w = qt_mac_aqua_get_metric(kThemeMetricSmallVSliderWidth);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricSmallVSliderTickWidth);
+                    }
+                } else if (sz == QAquaSizeMini) {
+                    if (sld->orientation() == Qt::Horizontal) {
+                        w = qt_mac_aqua_get_metric(kThemeMetricMiniHSliderHeight);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricMiniHSliderTickHeight);
+                    } else {
+                        w = qt_mac_aqua_get_metric(kThemeMetricMiniVSliderWidth);
+                        if (sld->tickPosition() != QSlider::NoTicks)
+                            w += qt_mac_aqua_get_metric(kThemeMetricMiniVSliderTickWidth);
+                    }
                 }
+            } else {
+                // This is tricky, we were requested to find a size for a slider which is not
+                // a slider. We don't know if this is vertical or horizontal or if we need to
+                // have tick marks or not.
+                // For this case we will return an horizontal slider without tick marks.
+                w = qt_mac_aqua_get_metric(kThemeMetricHSliderHeight);
+                w += qt_mac_aqua_get_metric(kThemeMetricHSliderTickHeight);
             }
-        } else {
-            // This is tricky, we were requested to find a size for a slider which is not
-            // a slider. We don't know if this is vertical or horizontal or if we need to
-            // have tick marks or not.
-            // For this case we will return an horizontal slider without tick marks.
-            w = qt_mac_aqua_get_metric(kThemeMetricHSliderHeight);
-            w += qt_mac_aqua_get_metric(kThemeMetricHSliderTickHeight);
+            if (sld->orientation() == Qt::Horizontal)
+                ret.setHeight(w);
+            else
+                ret.setWidth(w);
+            break;
         }
-        if (sld->orientation() == Qt::Horizontal)
-            ret.setHeight(w);
-        else
-            ret.setWidth(w);
-        break;
-    }
-#if QT_CONFIG(progressbar)
-    case QStyle::CT_ProgressBar: {
-        int finalValue = -1;
-        Qt::Orientation orient = Qt::Horizontal;
-        if (const QProgressBar *pb = qobject_cast<const QProgressBar *>(widg))
-            orient = pb->orientation();
-
-        if (sz == QAquaSizeLarge)
-            finalValue = qt_mac_aqua_get_metric(kThemeMetricLargeProgressBarThickness)
-                            + qt_mac_aqua_get_metric(kThemeMetricProgressBarShadowOutset);
-        else
-            finalValue = qt_mac_aqua_get_metric(kThemeMetricNormalProgressBarThickness)
-                            + qt_mac_aqua_get_metric(kThemeMetricSmallProgressBarShadowOutset);
-        if (orient == Qt::Horizontal)
-            ret.setHeight(finalValue);
-        else
-            ret.setWidth(finalValue);
-        break;
-    }
-#endif
-#if QT_CONFIG(combobox)
-    case QStyle::CT_LineEdit:
-        if (!widg || !qobject_cast<QComboBox *>(widg->parentWidget())) {
-            //should I take into account the font dimentions of the lineedit? -Sam
+#ifndef QT_NO_PROGRESSBAR
+        case QStyle::CT_ProgressBar: {
+            int finalValue = -1;
+            Qt::Orientation orient = Qt::Horizontal;
+            if (const QProgressBar *pb = qobject_cast<const QProgressBar *>(widg))
+                orient = pb->orientation();
+            
             if (sz == QAquaSizeLarge)
-                ret = QSize(-1, 21);
+                finalValue = qt_mac_aqua_get_metric(kThemeMetricLargeProgressBarThickness)
+                + qt_mac_aqua_get_metric(kThemeMetricProgressBarShadowOutset);
             else
-                ret = QSize(-1, 19);
+                finalValue = qt_mac_aqua_get_metric(kThemeMetricNormalProgressBarThickness)
+                + qt_mac_aqua_get_metric(kThemeMetricSmallProgressBarShadowOutset);
+            if (orient == Qt::Horizontal)
+                ret.setHeight(finalValue);
+            else
+                ret.setWidth(finalValue);
+            break;
         }
-        break;
 #endif
-    case QStyle::CT_HeaderSection:
-#if QT_CONFIG(treeview)
-        if (isTreeView(widg))
-           ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricListHeaderHeight));
+#ifndef QT_NO_COMBOBOX
+        case QStyle::CT_LineEdit:
+            if (!widg || !qobject_cast<QComboBox *>(widg->parentWidget())) {
+                //should I take into account the font dimentions of the lineedit? -Sam
+                if (sz == QAquaSizeLarge)
+                    ret = QSize(-1, 21);
+                else
+                    ret = QSize(-1, 19);
+            }
+            break;
 #endif
-        break;
-    case QStyle::CT_MenuBar:
-        if (sz == QAquaSizeLarge) {
-            ret = QSize(-1, [[NSApp mainMenu] menuBarHeight]);
-            // In the qt_mac_set_native_menubar(false) case,
-            // we come it here with a zero-height main menu,
-            // preventing the in-window menu from displaying.
-            // Use 22 pixels for the height, by observation.
-            if (ret.height() <= 0)
-                ret.setHeight(22);
-        }
-        break;
-    default:
-        break;
+        case QStyle::CT_HeaderSection:
+#ifndef QT_NO_TREEVIEW
+            if (isTreeView(widg))
+                ret = QSize(-1, qt_mac_aqua_get_metric(kThemeMetricListHeaderHeight));
+#endif
+            break;
+        case QStyle::CT_MenuBar:
+            if (sz == QAquaSizeLarge) {
+                ret = QSize(-1, [[NSApp mainMenu] menuBarHeight]);
+                // In the qt_mac_set_native_menubar(false) case,
+                // we come it here with a zero-height main menu,
+                // preventing the in-window menu from displaying.
+                // Use 22 pixels for the height, by observation.
+                if (ret.height() <= 0)
+                    ret.setHeight(22);
+            }
+            break;
+        default:
+            break;
     }
     return ret;
 }
@@ -952,7 +950,7 @@ static QSize qt_aqua_get_known_size(QStyle::ContentsType ct, const QWidget *widg
 static QAquaWidgetSize qt_aqua_guess_size(const QWidget *widg, QSize large, QSize small, QSize mini)
 {
     Q_UNUSED(widg);
-
+    
     if (large == QSize(-1, -1)) {
         if (small != QSize(-1, -1))
             return QAquaSizeSmall;
@@ -966,8 +964,8 @@ static QAquaWidgetSize qt_aqua_guess_size(const QWidget *widg, QSize large, QSiz
     } else if (mini == QSize(-1, -1)) {
         return QAquaSizeLarge;
     }
-
-#if QT_CONFIG(mainwindow)
+    
+#ifndef QT_NO_MAINWINDOW
     if (qEnvironmentVariableIsSet("QWIDGET_ALL_SMALL")) {
         //if (small.width() != -1 || small.height() != -1)
         return QAquaSizeSmall;
@@ -975,11 +973,11 @@ static QAquaWidgetSize qt_aqua_guess_size(const QWidget *widg, QSize large, QSiz
         return QAquaSizeMini;
     }
 #endif
-
+    
 #if 0
     /* Figure out which size we're closer to, I just hacked this in, I haven't
-       tested it as it would probably look pretty strange to have some widgets
-       big and some widgets small in the same window?? -Sam */
+     tested it as it would probably look pretty strange to have some widgets
+     big and some widgets small in the same window?? -Sam */
     int large_delta=0;
     if (large.width() != -1) {
         int delta = large.width() - widg->width();
@@ -1018,54 +1016,36 @@ static QAquaWidgetSize qt_aqua_guess_size(const QWidget *widg, QSize large, QSiz
 
 void QMacStylePrivate::drawFocusRing(QPainter *p, const QRect &targetRect, int hMargin, int vMargin, qreal radius) const
 {
-    const qreal pixelRatio = p->device()->devicePixelRatioF();
+    qreal pixelRatio = p->device()->devicePixelRatioF();
     static const QString keyFormat = QLatin1String("$qt_focusring%1-%2-%3-%4");
     const QString &key = keyFormat.arg(hMargin).arg(vMargin).arg(radius).arg(pixelRatio);
     QPixmap focusRingPixmap;
     const qreal size = radius * 2 + 5;
-
+    
     if (!QPixmapCache::find(key, focusRingPixmap)) {
         focusRingPixmap = QPixmap((QSize(size, size) + 2 * QSize(hMargin, vMargin)) * pixelRatio);
         focusRingPixmap.fill(Qt::transparent);
         focusRingPixmap.setDevicePixelRatio(pixelRatio);
         {
-            const CGFloat focusRingWidth = radius > 0 ? 3.5 : 6;
             QMacAutoReleasePool pool;
-            QMacCGContext ctx(&focusRingPixmap);
-            CGContextBeginTransparencyLayer(ctx, NULL);
-            CGContextSetAlpha(ctx, 0.5); // As applied to the stroke color below
-
-            [NSGraphicsContext saveGraphicsState];
-            [NSGraphicsContext setCurrentContext:[NSGraphicsContext graphicsContextWithCGContext:ctx
-                                                                                         flipped:NO]];
-            CGRect focusRingRect = CGRectMake(hMargin, vMargin, size, size);
             NSBezierPath *focusRingPath;
-            if (radius > 0) {
-                const CGFloat roundedRectInset = -1.5;
-                focusRingPath = [NSBezierPath bezierPathWithRoundedRect:NSRectFromCGRect(CGRectInset(focusRingRect, roundedRectInset, roundedRectInset))
+            if (radius > 0)
+                focusRingPath = [NSBezierPath bezierPathWithRoundedRect:NSMakeRect(hMargin, vMargin, size, size)
                                                                 xRadius:radius
                                                                 yRadius:radius];
-            } else {
-                const CGFloat outerClipInset = -focusRingWidth / 2;
-                NSBezierPath *focusRingClipPath = [NSBezierPath bezierPathWithRect:NSRectFromCGRect(CGRectInset(focusRingRect, outerClipInset, outerClipInset))];
-                const CGFloat innerClipInset = 1;
-                NSBezierPath *focusRingInnerClipPath = [NSBezierPath bezierPathWithRect:NSRectFromCGRect(CGRectInset(focusRingRect, innerClipInset, innerClipInset))];
-                [focusRingClipPath appendBezierPath:focusRingInnerClipPath.bezierPathByReversingPath];
-                [focusRingClipPath setClip];
-                focusRingPath = [NSBezierPath bezierPathWithRect:NSRectFromCGRect(focusRingRect)];
-                focusRingPath.lineJoinStyle = NSRoundLineJoinStyle;
-            }
-
-            focusRingPath.lineWidth = focusRingWidth;
-            [[NSColor keyboardFocusIndicatorColor] setStroke];
-            [focusRingPath stroke];
-
-            CGContextEndTransparencyLayer(ctx);
+            else
+                focusRingPath = [NSBezierPath bezierPathWithRect:NSMakeRect(hMargin, vMargin, size, size)];
+            [NSGraphicsContext saveGraphicsState];
+            QMacCGContext gc(&focusRingPixmap);
+            [NSGraphicsContext setCurrentContext:[NSGraphicsContext graphicsContextWithGraphicsPort:(CGContextRef)gc
+                                                                                            flipped:NO]];
+            NSSetFocusRingStyle(NSFocusRingOnly);
+            [focusRingPath fill];
             [NSGraphicsContext restoreGraphicsState];
         }
         QPixmapCache::insert(key, focusRingPixmap);
     }
-
+    
     // Add 2 for the actual ring tickness going inwards
     const qreal hCornerSize = 2 + hMargin + radius;
     const qreal vCornerSize = 2 + vMargin + radius;
